<?php
/*
	Phantom 
	randomUniqueId.php
	This script contains functions to create a unique UID
	Copyright  2011, SplashData
	Written under contract by Robosoft Technologies Pvt. Ltd.
*/


/*
	Function 	:randomPassword($length, $allow)
	Brief 		:randomPassword  generates random key
	Detail 		:This member function generates a random number 
	Input param :$length- length of random no., $allow- content of random no.
	Input/ output param : $ret - random number
	Return 		:Returns random number
*/
function randomPassword($length, $allow = "ABCDEF1234567890abcdef") {
		$i = 1;
		while ($i <= $length) {
			$max = strlen($allow)-1;
			$num = rand(0, $max);
			$temp = substr($allow, $num, 1);
			$ret = $ret . $temp;
			$i++;
		}
		return $ret;
} 
		
/*
	Function 	:uniqueId()
	Brief 		:uniqueId  is used for unique ID Generation
	Detail 		:This member function generates unique id by merging random no and timestamp
	Input param :none
	Input/ output param : $uniqueId - unique id
	Return 		:Returns unique id
*/
function uniqueId(){
		$randNo = strtoupper(randomPassword(8));  
		$timestamp1 = time();
		$timestamp2 = dechex($timestamp1);
		$timestamp3 = substr($timestamp2,-8);
		$timeNo = strtoupper($timestamp3);
		$uniqueId = $randNo.$timeNo;
		return $uniqueId;
}


/*
	Function 	:checkIdExistence($uniqueId,$field,$table)
	Brief 		:checkIdExistence  is used for checking unique ID existence in Database
	Detail 		:This member function checks if the generated id already exists in DB
	Input param :$uniqueId - id to be checked,$field - field name in DB(RECORDID or TYPEID),$table - db table
	Input/ output param : $idExists - 0 or 1
	Return 		:Returns 0 or 1
*/
function checkIdExistence($uniqueId,$field,$table){
	
		$idExists = 0;
		$checkIdExists = "Select ".$field." from ".$table." where ".$field."='$uniqueId'";
		$resultId = mysql_query($checkIdExists) or die("checkIdExists error ".mysql_error());
		$idExists = mysql_num_rows($resultId);
		return $idExists;
	
}

	
?>